datablock DebrisData(SeawolfExplosionDebris1)
{
   emitters = "VehicleExplosionEmitter";

	shapeFile = "./shapes/deb1.dts";
	lifetime = 6.0;
	minSpinSpeed = -30.0;
	maxSpinSpeed = 30.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 0.4;
};
datablock DebrisData(SeawolfExplosionDebris2 : SeawolfExplosionDebris1)
{
   emitters = "VehicleExplosionEmitter";
	shapeFile = "./shapes/deb2.dts";
   minSpinSpeed = -30.0;
   maxSpinSpeed = 30.0;

   gravModifier = 0.4;
   numBounces = 1;
   staticOnMaxBounce = true;
	
};
datablock DebrisData(SeawolfExplosionDebris3 : SeawolfExplosionDebris1)
{
   emitters = "VehicleExplosionEmitter";
	shapeFile = "./shapes/deb3.dts";
   minSpinSpeed = -30.0;
   maxSpinSpeed = 10.0;

   gravModifier = 0.4;
   numBounces = 1;
   staticOnMaxBounce = true;
};
datablock DebrisData(SeawolfExplosionDebris4 : SeawolfExplosionDebris1)
{
   emitters = "VehicleExplosionEmitter";
	shapeFile = "./shapes/deb4.dts";
   minSpinSpeed = -30.0;
   maxSpinSpeed = 10.0;

   gravModifier = 0.4;
   numBounces = 1;
   staticOnMaxBounce = true;
};
datablock ExplosionData(SeawolfFinalExplosion : vehicleFinalExplosion)
{
   debris = SeawolfExplosionDebris1;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 180;
   debrisThetaMin = 0;
   debrisThetaMax = 90;
   debrisVelocity = 5;
   debrisVelocityVariance = 15;
   damageRadius = 10;
   radiusDamage = 500;
   
   impulseRadius = 0;
   impulseForce = 0;


};
datablock ExplosionData(SeawolfFinalExplosion2 : SeawolfFinalExplosion)
{
	particleEmitter = "";
   debris = SeawolfExplosionDebris2;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 180;
   debrisThetaMin = 0;
   debrisThetaMax = 90;
   debrisVelocity = 5;
   debrisVelocityVariance = 15;
   damageRadius = 10;
   radiusDamage = 500;


};
datablock ExplosionData(SeawolfFinalExplosion3 : SeawolfFinalExplosion)
{
	particleEmitter = "";
   debris = SeawolfExplosionDebris3;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 180;
   debrisThetaMin = 0;
   debrisThetaMax = 90;
   debrisVelocity = 5;
   debrisVelocityVariance = 15;
   damageRadius = 10;
   radiusDamage = 500;

};
datablock ExplosionData(SeawolfFinalExplosion4 : SeawolfFinalExplosion)
{
	particleEmitter = "";
   debris = SeawolfExplosionDebris4;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 180;
   debrisThetaMin = 0;
   debrisThetaMax = 90;
   debrisVelocity = 5;
   debrisVelocityVariance = 15;
   damageRadius = 10;
   radiusDamage = 500;

};
//Debris
AddDamageType("SeawolfExp",   '<color:FFFF00>[Seawolf Explosion]<color:FF0000> %1',    '%2 <color:FFFF00>[Seawolf Explosion]<color:FF0000> %1',0.2,1);
datablock ProjectileData(SeawolffinalExplosionProjectile1 : vehicleFinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 20;
   damageRadius        = 500;
   explosion           = SeawolfFinalExplosion;

   directDamageType  = $DamageType::SeawolfExp;
   radiusDamageType  = $DamageType::SeawolfExp;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 0;


};

datablock ProjectileData(SeawolffinalExplosionProjectile2 : SeawolffinalExplosionProjectile1)
{
	explosion           = SeawolfFinalExplosion2;
};
//new-----------------------


datablock ProjectileData(SeawolffinalExplosionProjectile3 : SeawolffinalExplosionProjectile1)
{
	explosion           = SeawolfFinalExplosion3;
};
//new-----------------------


datablock ProjectileData(SeawolffinalExplosionProjectile4 : SeawolffinalExplosionProjectile1)
{
	explosion           = SeawolfFinalExplosion4;
};

