package Seawolf_shootonclick_Pack
{
	//Next seat => switch weapons
	function serverCmdNextSeat(%client)
	{

		%p = %client.player;
		if (!isobject(%p.getobjectmount()))
			return Parent::serverCmdNextSeat(%client);

		if (%p.getobjectmount().getdatablock() == SeawolfVehicle.getid() && !isObject(%p.getobjectmount().uav))
		{
			%boat = %p.getobjectmount();
			//applies the settings for each weapon
			%boat.errorText = ""; 
			switch (%boat.weaponi)
			{

			case 0:
				%boat.weaponi = 1;
				%boat.weapon = "Homing Torpedo";
				%boat.getdatablock().schedule(500,"Scan",%boat);
				%boat.targetText = "";
				%boat.unmountimage(2);
				%boat.mountimage(Seawolfhatchclosedimage,2);


			case 1:
				%boat.weaponi = 2;
				%boat.weapon = "UAV Designated Missile";
				%boat.targetText = "";
				%boat.unmountimage(2);
				%boat.mountimage(Seawolfhatchclosedimage,2);

			case 2:
				%boat.weaponi = 0;
				%boat.weapon = "Torpedo";
				//%boat.mountimage(Seawolfhatchcloseimage,2);
				%boat.targetText = "";
			}
		}
		else
		{
			Parent::serverCmdNextSeat(%client);
		}
	}

	function armor::onTrigger(%db,%obj,%slot,%val)
	{

		if (%obj.getObjectmount() == 0)
			return Parent::onTrigger(%db,%obj,%slot,%val);

		if (%obj.getObjectmount().getDatablock() == SeawolfVehicle.getID())
		{

			if (%obj.getClassName()$="Player")
			{

				if (%slot==0)
				{

					if (%val)
					{
						if (isObject(%obj.getObjectmount().torpedo) && %obj.getObjectmount().torpedo.life < 98) {
							%obj.getObjectmount().torpedo.dead = true;
							return;
						}
						if ($Sim::Time<%obj.client.SeawolfSOC_LastFireTime[%obj.getObjectmount().getid().weaponi])
						{
							return;
						}

					}
					

					%obj.SeawolfSOC_Shoot(%slot,%val,%obj.getObjectmount().weaponi,0);

				}

			}

		}
		return Parent::onTrigger(%db,%obj,%slot,%val);
	}
	function Projectile::onAdd(%obj,%a,%b)
	{
		switch (%obj.dataBlock.getID())
		{
			case SeawolfTorpedoHomingProjectile.getID():
				%obj.schedule(200,spawnSeawolfTorpedo,%obj.target);
			case SeawolfTorpedoProjectile.getID():
				%obj.schedule(100,spawnSeawolfTorpedo,0);
			case SeawolfICBMProjectile.getID():
				%obj.schedule(5000,spawnSeawolfICBM,%obj.target);
				case SeawolfICBMProjectile2.getID():
				%obj.schedule(100,spawnSeawolfICBM,%obj.target);
		}


		Parent::onAdd(%obj,%a,%b);
	}

};
ActivatePackage(Seawolf_shootonclick_Pack);

function repeatedVectorAddwithScale(%vecs)
{
	%vec="0 0 0";
	%cnt=getFieldCount(%vecs);
	for (%i=0; %i<%cnt; %i++)
	{
		%fld=getField(%vecs,%i);
		%tvec=getWords(%fld,0,3);
		%scale=getWord(%fld,3);
		%svec=vectorScale(%tvec,%scale);
		%vec=vectorAdd(%vec,%svec);
	}
	return %vec;
}

function SimObject::getLeftVector(%obj)
{
	return vectorCross(%obj.getEyeVector(),%obj.getUpVector());
}

function SimObject::getRightVector(%obj)
{
	return vectorScale(%obj.getLeftVector(%obj),-1);
}

function Player::SeawolfSOC_Shoot(%obj,%slot,%val,%weaponi,%icbmTarget)
{
	if (!%val)
	{
		cancel(%obj.SeawolfSOC_reshoot[%weaponi]);
		return;
	}
	%mnt= %obj.getObjectMount();

	if (!isObject(%mnt))
	{
		return;
	}

	%data= %mnt.getDatablock();

	%mountObj= %mnt.getMountNodeObject(%data.SeawolfshootOnClick_RequiredSlot[%weaponi]);
	if (%mountObj!$=%Obj)
	{
		return;
	}

	if (isObject(%mnt.uav) && %weaponi != 3) {
		return;
	}
	if  (%weaponi == 2) {
		if (!%mnt.hasUAV)
			return;
		else 
			%mnt.hasUAV = false;
		if(isObject(Waterplane)) {
			if (%mnt.depth > SeawolfVehicle.surfaceOffset || !%mnt.depthlock) {
				return;
			}
		}
	}
	if (%data.SeawolfShootOnClick)
	{

		if (%mnt.getDatablock() == SeawolfVehicle.getID())
		{

			//Checks OK, shoot it all.
			%cnt = %data.SeawolfshootOnClick_ProjectileCount[%weaponi];
			for (%i=0; %i<%cnt; %i++)
			{
				%player = %mnt.getMountNodeObject(0);
				%pos = %mnt.getTransform();
				%PVec= %data.SeawolfshootOnClick_Position[%weaponi,%i];
				%VVec= %data.SeawolfshootOnClick_Velocity[%weaponi,%i];
				%fVec= %data.SeawolfshootOnClick_flashVelocity[%weaponi,%i];

				%iPos= repeatedVectorAddwithScale(
				           %mnt.getEyeVector() SPC getWord(%PVec,0) TAB
				           %mnt.getLeftVector() SPC getWord(%PVec,1) TAB
				           %mnt.getUpVector() SPC getWord(%PVec,2)
				       );
				%iVel= repeatedVectorAddwithScale(
				           %mnt.getEyeVector() SPC getWord(%VVec,0) TAB
				           %mnt.getLeftVector() SPC getWord(%VVec,1) TAB
				           %mnt.getUpVector() SPC getWord(%VVec,2)
				       );
				%fVel= repeatedVectorAddwithScale(
				           %mnt.getEyeVector() SPC getWord(%fVec,0) TAB
				           %mnt.getLeftVector() SPC getWord(%fVec,1) TAB
				           %mnt.getUpVector() SPC getWord(%fVec,2)
				       );
				%scale=%data.SeawolfshootOnClick_Scale[%weaponi,%i];
				if (%scale$="")
				{
					%scale="1 1 1";
				}
				%spread = %data.SeawolfshootOnClick_Spread[%weaponi,%i];
				%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
				%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
				%velocity = MatrixMulVector(%mat, %iVel);

				switch (%weaponi) {
					case 0:
						
						%p= new Projectile()
						{
							dataBlock= %data.SeawolfshootOnClick_Projectile[%weaponi,%i];
							initialPosition= vectorAdd(%pos,%iPos);
							initialVelocity= %velocity;
							sourceObject= %obj;
							client= %obj.client;
							sourceSlot= %slot;
							scale= %scale;
							target = %mnt.target;
						};
						missionCleanup.add(%p);
						%p.life = 20000/200;
						%mnt.torpedo = %P;
					case 1:
						
						%p= new Projectile()
						{
							dataBlock= %data.SeawolfshootOnClick_Projectile[%weaponi,%i];
							initialPosition= vectorAdd(%pos,%iPos);
							initialVelocity= %velocity;
							sourceObject= %obj;
							client= %obj.client;
							sourceSlot= %slot;
							scale= %scale;
							target = %mnt.target;
						};
						missionCleanup.add(%p);
						%p.life = 20000/200;
						%mnt.torpedo = %P;
					case 2:
						%p = new WheeledVehicle()
						{
							dataBlock = SeawolfUAVVehicle;
						};
						MissionCleanup.add(%p);
						%p.rotation = rotateEuler(%mnt.getTransform(),"10 0 0");
						%p.setTransform(vectorAdd(%pos,%iPos) SPC %p.rotation);
						%p.setVelocity(vectorScale(%p.getForwardVector(),20 + vectorLen(%mnt.getVelocity())));
						%p.pilot = %player;
						%p.sub = %mnt;
						%p.creationTime = getSimTime();
						%p.battery = 100;
						%mnt.uav = %p;
						
						%p.setNodeColor("ALL",getColorIDTable(%mnt.spawnbrick.getColorID()));
					case 3:
						%p= new Projectile()
						{
							dataBlock= %data.SeawolfshootOnClick_Projectile[%weaponi,%i];
							initialPosition= vectorAdd(%pos,%iPos);
							initialVelocity= %velocity;
							sourceObject= %obj;
							client= %obj.client;
							sourceSlot= %slot;
							scale= %scale;
							subHeight = getWord(%mnt.getTransform(),2);
							target = vectorAdd(%icbmTarget,"0 0" SPC getWord(%mnt.getTransform(),2) + SeawolfVehicle.icbm_targetHeightOffset);
							finalStage = false;
						};
						missionCleanup.add(%p);

				}

				

				serverPlay3d(%data.SeawolfshootOnClick_Sound[%weaponi],%pos);


				%tank = %mnt.getObjectMount();


				if (%data.SeawolfshootOnClick_FlashProjectile[%weaponi])
				{
					%s = new Projectile()
					{
						dataBlock = %data.SeawolfshootOnClick_FlashProjectile[%weaponi];
						initialPosition = vectorAdd(%pos,%iPos);
						initialVelocity = %fVel;
						client = %obj.client;
						sourceObject= %obj;
						sourceSlot= %slot;
						scale= %scale;

					};
					MissionCleanup.add(%s);
				}

				if (%data.SeawolfshootOnClick_Hold[%weaponi])
				{
					%obj.SeawolfSOC_reshoot[%weaponi] = %obj.schedule(%data.SeawolfshootOnClick_ReshootDelay[%weaponi],SeawolfSOC_Shoot,%slot,%val,%weaponi,%icbmTarget);
				}
				%obj.client.SeawolfSOC_LastFireTime[%weaponi]=$Sim::Time+%data.SeawolfshootOnClick_ShootDelay[%weaponi]/1000;

			}
		}
	}

}

function SeawolfVehicle::Scan(%this,%obj)
{

	if (isObject(%obj) && %obj.weaponi == 1)
	{
		if (isObject(%obj.getMountNodeObject(0)))
		{
			serverPlay3d(SeawolfPingSound,%obj.getPosition());
			%mask = $TypeMasks::VehicleObjectType;
			%eyeVec   = %obj.getEyeVector();
			%eyeTrans = %obj.getEyeTransform();
			%eyePos = getWords(posFromTransform(%eyeTrans),0,2);
			%nEyeVec = VectorNormalize(%eyeVec);

			for (%i = 20; %i <= 500; %i+=5)
			{
				%scanningRadius = 2;
				%scEyeVec = VectorScale(%nEyeVec, %i);
				%eyeEnd = VectorAdd(%eyePos, %scEyeVec);
				%searchResult = containerFindFirst(%mask, %eyeEnd,%scanningRadius,%scanningRadius,%scanningRadius);

				// %p = new Projectile()
				// {
				//  dataBlock = vehicleExplosionProjectile;
				//  initialPosition = %eyeEnd;
				//  scale = "0.1 0.1 0.1";
				// };
				// MissionCleanup.add(%p);


				if (isobject(%searchResult))
				{
					%obj.target = %searchResult;
					%obj.targetText = getWord(%searchResult,0).getDatablock().uiname;
					break;
				}
				else
				{
					%obj.target = "";
					%obj.targetText = "N/A";
				}
			}

		}
		%obj.getdatablock().schedule(4000,"Scan",%obj);
	}

}
function Projectile::fireWarhead(%this){
	%pos = %this.getPosition();
	%vel = %this.getVelocity();

	for (%i = 0; %i < SeawolfVehicle.icbm_warheadCount; %i++) {
		%spread = SeawolfVehicle.icbm_warheadSpread;
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %vel);

		%p= new Projectile()
		{
			dataBlock= SeawolfICBMWarhead;
			initialPosition= %pos;
			initialVelocity= (%i == 0 ? %vel : %velocity);
			sourceObject= %this.sourceobject;
			client= %this.client;
			sourceSlot= %this.slot;
			scale= "2 2 2";
		};
		missionCleanup.add(%p);
	}
	


	%this.delete();
}
function Projectile::spawnSeawolfICBM(%this,%target)
{

	if (!isObject(%this.client))
		return;
	if (!isObject(%this) || vectorLen(%this.getVelocity()) == 0)
		return;
	%pos = %this.getPosition();

	if (!%this.finalStage && VectorDist(%pos,%target) < 50)
	{
		%this.finalStage = true;
		%target = vectorAdd(%target,"0 0 -" @ %this.subHeight + Seawolfvehicle.icbm_targetHeightOffset);
	}

	if (%this.finalStage && getWord(%pos,2) < getWord(%target,2) + Seawolfvehicle.icbm_DetonationHeightDiffence)
	{
		%this.fireWarhead();
		return;
	}

	if(strLen(%target) > 0)
	{
		%radius = 100;
		%minDist = 9000;
		%pos = %this.getPosition();
		%start = %pos;
		%end = %target;
		%muzzle = vectorLen(%this.getVelocity());
		%vec = vectorNormalize(vectorSub(%end,%start));
		for (%i=0; %i<5; %i++)
		{
			%t = vectorDist(%start,%end) / vectorLen(vectorScale(getWord(%vec,0) SPC getWord(%vec,1),%muzzle));
			%velaccl = vectorScale(%accl,%t);

			%x = getword(%velaccl,0);
			%y = getword(%velaccl,1);
			%z = getWord(%velaccl,2);

			%x = (%x < 0 ? 0 : %x);
			%y = (%y < 0 ? 0 : %y);
			%z = (%z < 0 ? 0 : %z);

			%vel = %x SPC %y SPC %z;
			%end = %target;
			%vec = vectorNormalize(vectorSub(%end,%start));
		}
		%addVec = vectorAdd(%this.getVelocity(),vectorScale(%vec,1000/vectorDist(%pos,%end)*(%muzzle/10)));
		%vec = vectorNormalize(%addVec);
		%p = new Projectile()
		{
			dataBlock = SeawolfICBMProjectile2;
			initialPosition = %pos;
			initialVelocity = vectorScale(%vec,SeawolfICBMProjectile2.muzzleVelocity);
			sourceobject = %this.sourceObject;
			client = %this.client;
			sourceSlot = 0;
			target = %target;
			subHeight = %this.subHeight;
			finalStage = %this.finalStage;
		};
		if (isObject(%p))
		{
			MissionCleanup.add(%p);
			%this.delete();
		}

		//schedule(200,0,spawnSeawolfICBM,%this,%target);
	}

	
}
function Projectile::spawnSeawolfTorpedo(%this,%target)
{
	if (!isObject(%this.client))
		return;
	if (!isObject(%this) || vectorLen(%this.getVelocity()) == 0)
		return;
	if (!isObject(%this.sourceObject) || !isObject(%this.sourceObject.getobjectmount()))
		return;


	%this.life--;
	if (%this.life <= 0)
	{
		%this.explode();
		return;
	}

	%player = %this.sourceObject;
	%mnt = %player.getobjectmount();
	if (!isObject(Waterplane))
		return;
	%waterlevel = getWord(Waterplane.getTransform(),2);

	%pos = %this.getPosition();
	if (isobject(%target))
	{
		if (VectorDist(%pos,%target.getposition()) < 5)
		{
			%this.explode();
			return;
		}
	}
	if(%this.dead)	{
		%this.explode();
		return;
	}


	%muzzle = vectorLen(%this.getVelocity());

	// %flaresearchMasks = $TypeMasks::ProjectileObjectType;
	// %flareSearch = containerFindFirst($TypeMasks::ProjectileObjectType, %pos , 100, 100, 100);
	// if(%targetIn.isFlare == false)
	// {
	//  if(getword(%targetIn.getTypeStrings(),2) != $TypeMasks::ProjectileObjectType && isobject(%flareSearch))
	//  {
	//      if(%flareSearch.isflare == 1)
	//      {
	//          %targetIn.islocked = false;
	//          %targetIn = %flareSearch;
	//      }
	//  }
	// }
	if (getWord(%pos,2) > %waterlevel)
	{
		%pos = %this.getPosition();
		%p = new Projectile()
		{
			dataBlock = %this.getDatablock();
			initialPosition = vectorAdd(%pos,"0 0 -0.3");
			initialVelocity = getWords(%this.getVelocity(),0,1) SPC 0;
			sourceobject = %this.sourceObject;
			client = %this.client;
			sourceSlot = 0;
		};
		if (isObject(%p))
		{
			%p.target=%targetIn;
			%mnt.torpedo = %p;
			MissionCleanup.add(%p);
			%p.life = %this.life;
			%mnt.torpedo = %P;
			//schedule(200,0,SeawolftorpedoCheck,%p,%p.target);
			%this.delete();
		}
		schedule(200,0,SeawolftorpedoCheck,%this,0);
		return;
	}
	if (isobject(%target))
	{
		%radius = 100;
		%minDist = 9000;
		%found = %target;
		%pos = %this.getPosition();
		%start = %pos;
		%end = getWord(%found.getslottransform(0),2) > %waterlevel ? getWords(%found.getslottransform(0),0,1) SPC %waterlevel: %found.getslottransform(0);

		%vec = vectorNormalize(vectorSub(%end,%start));
		for (%i=0; %i<5; %i++)
		{
			%t = vectorDist(%start,%end) / vectorLen(vectorScale(getWord(%vec,0) SPC getWord(%vec,1),%muzzle));
			%velaccl = vectorScale(%accl,%t);

			%x = getword(%velaccl,0);
			%y = getword(%velaccl,1);
			%z = getWord(%velaccl,2);

			%x = (%x < 0 ? 0 : %x);
			%y = (%y < 0 ? 0 : %y);
			%z = (%z < 0 ? 0 : %z);

			%vel = vectorAdd(vectorScale(%found.getVelocity(),%t),%x SPC %y SPC %z);
			%end = getWord(%found.getslottransform(0),2) > %waterlevel ? getWords(%found.getslottransform(0),0,1) SPC %waterlevel: %found.getslottransform(0);
			%vec = vectorNormalize(vectorSub(%end,%start));
		}
		%addVec = vectorAdd(%this.getVelocity(),vectorScale(%vec,30/vectorDist(%pos,%end)*(%muzzle/10)));
		%vec = vectorNormalize(%addVec);
		%p = new Projectile()
		{
			dataBlock = SeawolfTorpedoHomingProjectile;
			initialPosition = %pos;
			initialVelocity = vectorScale(%vec,SeawolfTorpedoHomingProjectile.muzzleVelocity);
			sourceobject = %this.sourceObject;
			client = %this.client;
			sourceSlot = 0;
			target = %target;
		};
		if (isObject(%p))
		{
			%p.target=%targetIn;
			%mnt.torpedo = %p;
			MissionCleanup.add(%p);
			%p.life = %this.life;
			//schedule(200,0,SeawolftorpedoCheck,%p,%p.target);
			%this.delete();
		}
	}

	schedule(200,0,SeawolftorpedoCheck,%this,%target);

}
function SeawolftorpedoCheck(%this,%target)
{
	if (isobject(%this))
	{
		%this.schedule(50,spawnSeawolfTorpedo,%target);
	}

}
function rotateEuler(%a,%b) {
	%newAxis = axisToEuler(%a);
	return eulerToAxis(getWord(%newAxis,0) + getWord(%b,0) SPC getWord(%newAxis,1) + getWord(%b,1) SPC getWord(%newAxis,2) + getWord(%b,2)); 
}
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,6) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,3) * %sinThetaOver2;
	%q2 = getWord(%axis,4) * %sinThetaOver2;
	%q3 = getWord(%axis,5) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
